Index: TOOLS/WATER_BUDGET/ATM_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6446)
+++ TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6508)
@@ -25,161 +25,123 @@
 import configparser, re
 
-## Creates parser
-config = configparser.ConfigParser()
+# Check python version
+if sys.version_info < (3, 8, 0) :
+    print ( f'Python version : {platform.python_version()}' ) 
+    raise Exception ( "Minimum Python version is 3.8" )
+
+## Import local module
+import WaterUtils as wu
+
+## Creates parser for reading .ini input file
+config = configparser.ConfigParser (interpolation=configparser.ExtendedInterpolation() )
 config.optionxform = str # To keep capitals
 
-## Read experiment parameters
-ATM=None ; ORCA=None ; NEMO=None ; OCE_relax=False ; OCE_icb=False ; Coupled=False ; Routing=None ;  TarRestartPeriod_beg=None ; TarRestartPeriod_end=None ; Comment=None ; Period=None ; Title=None
+## Experiment parameters
+ATM=None ; ATM_HIS='latlon' ; SRF_HIS='latlon' ; RUN_HIS='latlon' ; ORCA=None ; NEMO=None ; OCE_relax=False ; OCE_icb=False ; Coupled=False ; Routing=None ; TarRestartPeriod_beg=None ; TarRestartPeriod_end=None ; Comment=None ; Period=None ; Title=None
 
 ##
-ARCHIVE =None ; STORAGE = None ; SCRATCHDIR=None ; R_IN=None ; rebuild=None
-TmpDir=None ; FileOut=None ; dir_ATM_his=None ; dir_SRF_his=None ; dir_OCE_his=None ; dir_ICE_his=None ; FileCommon=None
+ARCHIVE=None ; STORAGE=None ; SCRATCHDIR=None ; R_IN=None ; rebuild=None
+TmpDir=None ; RunDir=None ; FileOut=None ; dir_ATM_his=None ; dir_SRF_his=None ; dir_OCE_his=None ; dir_ICE_his=None ; FileCommon=None
 file_ATM_his=None ; file_SRF_his=None ; file_RUN_his=None ; file_OCE_his=None ;  file_ICE_his=None ; file_OCE_sca=None
-file_restart_beg=None ; file_restart_end=None ; file_ATM_beg=None ; file_ATM_end=None ; file_DYN_beg=None ; file_DYN_end=None ; file_SRF_beg=None ; file_SRF_end=None
-file_RUN_beg=None ; file_RUN_end=None ; file_RUN_end=None ; file_OCE_beg=None ; file_ICE_beg=None ; file_OCE_beg=None ; file_OCE_end=None
-
-d_ATM_his=None ; d_SRF_his=None ; d_RUN_his=None ; d_OCE_his=None ;  d_ICE_his=None ; d_OCE_sca=None
-d_restart_beg=None ; d_restart_end=None ; d_ATM_beg=None ; d_ATM_end=None ; d_DYN_beg=None ; d_DYN_end=None ; d_SRF_beg=None ; d_SRF_end=None
-d_RUN_beg=None ; d_RUN_end=None ; d_RUN_end=None ; d_OCE_beg=None ; d_ICE_beg=None ; d_OCE_beg=None ; d_OCE_end=None
-
-# Arguments passed
+tar_restart_beg=None ; tar_restart_end=None ; file_ATM_beg=None ; file_ATM_end=None ; file_DYN_beg=None ; file_DYN_end=None ; file_SRF_beg=None ; file_SRF_end=None
+file_RUN_beg=None ; file_RUN_end=None ; file_RUN_end=None ; file_OCE_beg=None ; file_ICE_beg=None ; file_OCE_beg=None ; file_OCE_end=None ; file_ICE_beg=None ; file_OCE_end=None ; file_ICE_end=None ; ContinueOnError=False ; ErrorCount=0
+tar_restart_beg_ATM=None ; tar_restart_beg_DYN=None ; tar_restart_beg_SRF=None ; tar_restart_beg_RUN=None ; tar_restart_beg_OCE=None ; tar_restart_beg_ICE=None
+tar_restart_end_ATM=None ; tar_restart_end_DYN=None ; tar_restart_end_SRF=None ; tar_restart_end_RUN=None ; tar_restart_end_OCE=None ; tar_restart_end_ICE=None
+SortIco = False
+
+# Read command line arguments
 print ( "Name of Python script:", sys.argv[0] )
 IniFile = sys.argv[1]
+# Text existence of IniFile
+if not os.path.exists (IniFile ) :
+    raise FileExistsError ( f"File not found : {IniFile = }" )
+
+if 'full' in IniFile : FullIniFile = IniFile
+else                 : FullIniFile = 'full_' + IniFile
+    
 print ("Input file : ", IniFile )
 config.read (IniFile)
 FullIniFile = 'full_' + IniFile
 
-def setBool (chars) :
-    '''Convert specific char string in boolean if possible'''
-    setBool = chars
-    for key in configparser.ConfigParser.BOOLEAN_STATES.keys () :
-        if chars.lower() == key : setBool = configparser.ConfigParser.BOOLEAN_STATES[key]
-    return setBool
-
-def setNum (chars) :
-    '''Convert specific char string in integer or real if possible'''
-    if type (chars) == str :
-        realnum = re.compile ("^[-+]?[0-9]*\.?[0-9]+(e[-+]?[0-9]+)?$")
-        isReal = realnum.match(chars.strip()) != None
-        isInt  = chars.strip().isdigit()
-        if isReal :
-            if isInt : setNum = int   (chars)
-            else     : setNum = float (chars)
-        else : setNum = chars
-    else : setNum = chars
-    return setNum
-
-def setNone (chars) :
-    '''Convert specific char string to None if possible'''
-    if type (chars) == str :
-        if chars in ['None', 'NONE', 'none'] : setNone = None
-        else : setNone = chars
-    else : setNone = chars
-    return setNone
-
-## Reading config
-for Section in ['Experiment', 'libIGCM', 'Files', 'Physics' ] :
-    if Section in config.keys() : 
-        print ( f'[{Section}]' )
+## Reading config file
+for Section in ['Config', 'Experiment', 'libIGCM', 'Files', 'Physics' ] :
+   if Section in config.keys () : 
+        print ( f'\nReading [{Section}]' )
         for VarName in config[Section].keys() :
             locals()[VarName] = config[Section][VarName]
-            locals()[VarName] = setBool (locals()[VarName])
-            locals()[VarName] = setNum  (locals()[VarName])
-            print ( '{:25} set to : {:}'.format (VarName, locals()[VarName]) )
-
-if not 'Files' in config.keys() : config['Files'] = {}
-
-def unDefined (char) :
-    if char in globals () :
-        if char == None : return True
-        else : return False
-    else : return True
-
+            exec  ( f'{VarName} = wu.setBool ({VarName})' )
+            exec  ( f'{VarName} = wu.setNum  ({VarName})' )
+            exec  ( f'{VarName} = wu.setNone ({VarName})' )
+            exec  ( f'wu.{VarName} = {VarName}' )
+            print ( f'{VarName:25} set to : {locals()[VarName]:}' )
+            #exec ( f'del {VarName}' )
+
+print ( f'\nConfig file readed : {IniFile} ' )
+            
 ##-- Some physical constants
-#-- Earth Radius
-if not 'Ra'            in locals () : Ra = 6366197.7236758135
-#-- Gravity
-if not 'Grav'          in locals () : Grav = 9.81
-#-- Ice volumic mass (kg/m3) in LIM3
-if not 'ICE_rho_ice'   in locals () : ICE_rho_ice = 917.0
-#-- Snow volumic mass (kg/m3) in LIM3
-if not 'ICE_rho_sno'   in locals () : ICE_rho_sno = 330.0
-#-- Ocean water volumic mass (kg/m3) in NEMO
-if not 'OCE_rho_liq'   in locals () : OCE_rho_liq = 1026.
-#-- Water volumic mass in atmosphere
-if not 'ATM_rho'       in locals () : ATM_rho = 1000.
-#-- Water volumic mass in surface reservoirs
-if not 'SRF_rho'       in locals () : SRF_rho = 1000.
-#-- Water volumic mass of rivers
-if not 'RUN_rho'       in locals () : RUN_rho = 1000.
-#-- Year length
-if not 'YearLength'    in locals () : YearLength = 365.25 * 24. * 60. * 60.
+if wu.unDefined ( 'Ra' )           : Ra          = 6366197.7236758135 #-- Earth Radius (m)
+if wu.unDefined ( 'Grav' )         : Grav        = 9.81               #-- Gravity (m^2/s
+if wu.unDefined ( 'ICE_rho_ice' )  : ICE_rho_ice = 917.0              #-- Ice volumic mass (kg/m3) in LIM3
+if wu.unDefined ( 'ICE_rho_sno')   : ICE_rho_sno = 330.0              #-- Snow volumic mass (kg/m3) in LIM3
+if wu.unDefined ( 'OCE_rho_liq' )  : OCE_rho_liq = 1026.0             #-- Ocean water volumic mass (kg/m3) in NEMO
+if wu.unDefined ( 'ATM_rho' )      : ATM_rho     = 1000.0             #-- Water volumic mass in atmosphere (kg/m^3)
+if wu.unDefined ( 'SRF_rho' )      : SRF_rho     = 1000.0             #-- Water volumic mass in surface reservoir (kg/m^3)
+if wu.unDefined ( 'RUN_rho' )      : RUN_rho     = 1000.0             #-- Water volumic mass of rivers (kg/m^3)
+if wu.unDefined ( 'ICE_rho_pnd' )  : ICE_rho_pnd = 1000.              #-- Water volumic mass in ice ponds (kg/m^3)
+if wu.unDefined ( 'YearLength' )   : YearLength  = 365.25 * 24. * 60. * 60. #-- Year length (s) - Use only to compute drif in approximate unit 
+            
+##-- Set libIGCM and machine dependant values
+if not 'Files' in config.keys () : config['Files'] = {}
 
 config['Physics'] = { 'Ra':Ra, 'Grav':Grav, 'ICE_rho_ice':ICE_rho_ice, 'ICE_rho_sno':ICE_rho_sno, 'OCE_rho_liq':OCE_rho_liq, 'ATM_rho':ATM_rho, 'SRF_rho':SRF_rho, 'RUN_rho':RUN_rho}
 
-## --
-ICO  = ( 'ICO' in ATM )
-LMDZ = ( 'LMD' in ATM )
-    
-
-# Where do we run ?
-SysName, NodeName, Release, Version, Machine = os.uname ()
-TGCC  = ( 'irene'   in NodeName )
-IDRIS = ( 'jeanzay' in NodeName )
-
-## Set site specific libIGCM directories, and other specific stuff
-if TGCC :
-    CPU = subprocess.getoutput ( 'lscpu | grep "Model name"' )
-    if "Intel(R) Xeon(R) Platinum" in CPU : Machine = 'irene'
-    if "AMD"                       in CPU : Machine = 'irene-amd'
-
-    if libIGCM : 
-        if ARCHIVE    == None : ARCHIVE     = subprocess.getoutput ( f'ccc_home --cccstore   -d {Project} -u {User}' )
-        if STORAGE    == None : STORAGE     = subprocess.getoutput ( f'ccc_home --cccwork    -d {Project} -u {User}' )
-        if SCRATCHDIR == None : SCRATCHDIR  = subprocess.getoutput ( f'ccc_home --cccscratch -d {Project} -u {User}' )
-        if R_IN       == None : R_IN        = os.path.join ( subprocess.getoutput ( f'ccc_home --cccwork -d igcmg -u igcmg' ), 'IGCM')
-        if rebuild    == None : rebuild     = os.path.join ( subprocess.getoutput ( f'ccc_home --ccchome -d igcmg -u igcmg' ), 'Tools', Machine, 'rebuild_nemo', 'bin', 'rebuild_nemo' )
-
-    ## Specific to run at TGCC.
-    # Needed before importing a NetCDF library (netCDF4, xarray, cmds, etc ...)
-    import mpi4py
-    mpi4py.rc.initialize = False
-        
-    ## Creates output directory
-    if TmpDir == None :
-        TmpDir = os.path.join ( subprocess.getoutput ( 'ccc_home --cccscratch' ), f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
-        config['Files']['TmpDir'] = TmpDir
-        
-if IDRIS :
-    raise Exception ("Pour IDRIS : repertoires et chemins a definir") 
-
-config['System'] = {'SysName':SysName, 'NodeName':NodeName, 'Release':Release, 'Version':Version,'Machine':Machine, 'TGCC':TGCC,'IDRIS':IDRIS, 'CPU':CPU,
-                    'Program'  : "Generated by : " + str(sys.argv), 
-                    'HOSTNAME' : platform.node (), 'LOGNAME'  : os.getlogin (),
-                    'Python'   : f'{platform.python_version ()}',
-                    'OS'       : f'{platform.system ()} release : {platform.release ()} hardware : {platform.machine ()}',
-                    'SVN_Author'   : "$Author$", 
-                    'SVN_Date'     : "$Date$",
-                    'SVN_Revision' : "$Revision$",
-                    'SVN_Id'       : "$Id$",
-                    'SVN_HeadURL'  : "$HeadURL$"}
+config['Config'] = { 'ContinueOnError':ContinueOnError, 'SortIco':SortIco}
+
+## --------------------------
+ICO  = ( 'ICO' in wu.ATM )
+LMDZ = ( 'LMD' in wu.ATM )
+    
+with open ('SetLibIGCM.py') as f: exec ( f.read() )
+config['Files']['TmpDir'] = TmpDir
 
 if libIGCM :
     config['libIGCM'] = {'ARCHIVE':ARCHIVE, 'STORAGE':STORAGE, 'SCRATCHDIR':SCRATCHDIR, 'R_IN':R_IN, 'rebuild':rebuild }
 
-## Import specific module
+##-- Import specific module
 import nemo, lmdz
-## Now import needed scientific modules
+##-- Now import needed scientific modules
 import xarray as xr
 
-# Output file
-if FileOut == None : 
-    FileOut = f'ATM_waterbudget_{JobName}_{YearBegin}_{YearEnd}.out'
-    config['Files']['FileOut'] = FileOut
+##- Output file with water budget diagnostics
+if wu.unDefined ( 'FileOut' ) : FileOut = f'ATM_waterbudget_{JobName}_{YearBegin}_{YearEnd}.out'
+config['Files']['FileOut'] = FileOut
 
 f_out = open ( FileOut, mode = 'w' )
 
-# Function to print to stdout *and* output file
+##- Useful functions
+def kg2Sv    (val, rho=ATM_rho) :
+    '''From kg to Sverdrup'''
+    return val/dtime_sec*1.0e-6/rho
+
+def kg2myear (val, rho=ATM_rho) :
+    '''From kg to m/year'''
+    return val/ATM_aire_sea_tot/rho/NbYear
+
+def var2prt (var, small=False, rho=ATM_rho) :
+    if small :  return var , kg2Sv(var, rho=rho)*1000., kg2myear(var, rho=rho)*1000.
+    else     :  return var , kg2Sv(var, rho=rho)      , kg2myear(var, rho=rho)
+
+def prtFlux (Desc, var, Form='F', small=False, rho=ATM_rho, width=15) :
+    if small :
+        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} mSv | {:12.4f} mm/year "
+        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} mSv | {:12.4e} mm/year "
+    else :
+        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} Sv  | {:12.4f} m/year  "
+        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} Sv  | {:12.4e} m/year  "
+    echo ( (' {:>{width}} = ' +ff).format (Desc, *var2prt(var, small, rho=rho), width=width ) )
+    return None
+
 def echo (string, end='\n') :
+    '''Function to print to stdout *and* output file'''
     print ( str(string), end=end  )
     sys.stdout.flush ()
@@ -188,62 +150,71 @@
     return None
     
-## Set libIGCM directories
-R_OUT       = os.path.join ( ARCHIVE   , 'IGCM_OUT')
-R_BUF       = os.path.join ( SCRATCHDIR, 'IGCM_OUT')
-
-L_EXP = os.path.join (TagName, SpaceName, ExperimentName, JobName)
-R_SAVE      = os.path.join ( R_OUT, L_EXP )
-R_BUFR      = os.path.join ( R_BUF, L_EXP )
-POST_DIR    = os.path.join ( R_BUF, L_EXP, 'Out' )
-REBUILD_DIR = os.path.join ( R_BUF, L_EXP, 'REBUILD' )
-R_BUF_KSH   = os.path.join ( R_BUFR, 'Out' )
-R_FIGR      = os.path.join ( STORAGE, 'IGCM_OUT', L_EXP )
-
-#if os.path.isdir (TmpDir) : shutil.rmtree ( TmpDir )
-if not os.path.isdir (TmpDir) : os.mkdir (TmpDir)
-TmpDirOCE = os.path.join (TmpDir, 'OCE')
-TmpDirICE = os.path.join (TmpDir, 'ICE')
-if not os.path.exists (TmpDirOCE) : os.mkdir (TmpDirOCE )
-if not os.path.exists (TmpDirICE) : os.mkdir (TmpDirICE )
+##- Set libIGCM directories
+if wu.unDefined ('R_OUT'      ) : R_OUT       = os.path.join ( ARCHIVE   , 'IGCM_OUT' )
+if wu.unDefined ('R_BUF'      ) : R_BUF       = os.path.join ( SCRATCHDIR, 'IGCM_OUT' )
+if wu.unDefined ('L_EXP'      ) : L_EXP       = os.path.join (TagName, SpaceName, ExperimentName, JobName)
+if wu.unDefined ('R_SAVE'     ) : R_SAVE      = os.path.join ( R_OUT, L_EXP )
+if wu.unDefined ('R_BUFR'     ) : R_BUFR      = os.path.join ( R_BUF, L_EXP )
+if wu.unDefined ('POST_DIR'   ) : POST_DIR    = os.path.join ( R_BUFR, 'Out' )
+if wu.unDefined ('REBUILD_DIR') : REBUILD_DIR = os.path.join ( R_BUFR, 'REBUILD' )
+if wu.unDefined ('R_BUF_KSH'  ) : R_BUF_KSH   = os.path.join ( R_BUFR, 'Out' )
+if wu.unDefined ('R_FIGR'     ) : R_FIGR      = os.path.join ( STORAGE, 'IGCM_OUT', L_EXP )
+
+config['libIGCM'] = { 'R_OUT':R_OUT, 'R_BUF':R_BUF, 'L_EXP':L_EXP, 'R_BUFR':R_BUFR, 'POST_DIR':POST_DIR, 'REBUILD_DIR':REBUILD_DIR, 'R_BUF_KSH':R_BUF_KSH, 'R_FIGR':R_FIGR }
+
+##- Set directory to extract files
+if wu.unDefined ( 'RunDir' ) : RunDir = os.path.join ( TmpDir, f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
+config['Files']['RunDir'] = RunDir
+
+if not os.path.isdir ( RunDir ) : os.makedirs ( RunDir )
+
+##- Set directories to rebuild ocean and ice restart files
+if wu.unDefined ( 'RunDirOCE' ) : RunDirOCE = os.path.join ( RunDir, 'OCE' )
+if wu.unDefined ( 'RunDirICE' ) : RunDirICE = os.path.join ( RunDir, 'ICE' )
+if not os.path.exists ( RunDirOCE ) : os.mkdir ( RunDirOCE )
+if not os.path.exists ( RunDirICE ) : os.mkdir ( RunDirICE )
 
 echo (' ')
-echo ( f'JobName : {JobName}' )
-echo (Comment)
-echo ( f'Working in TMPDIR : {TmpDir}' )
-
-echo ( f'\nDealing with {L_EXP}' )
-
-#-- Model output directories
+echo ( f'JobName   : {JobName}'   )
+echo ( f'Comment   : {Comment}'   )
+echo ( f'TmpDir    : {TmpDir}'    )
+echo ( f'RunDir    : {RunDir}'    )
+echo ( f'RunDirOCE : {RunDirOCE}' )
+echo ( f'RunDirICE : {RunDirICE}' )
+
+echo ( f'\nDealing with {L_EXP}'  )
+
+##-- Creates model output directory names
 if Freq == "MO" : FreqDir = os.path.join ('Output' , 'MO' )
 if Freq == "SE" : FreqDir = os.path.join ('Analyse', 'SE' )
-if dir_ATM_his == None :
+if wu.unDefined ('dir_ATM_his' ) :
     dir_ATM_his = os.path.join ( R_SAVE, "ATM", FreqDir )
     config['Files']['dir_ATM_his'] = dir_ATM_his
-if dir_SRF_his == None : 
+if wu.unDefined ( 'dir_SRF_his' ) : 
     dir_SRF_his = os.path.join ( R_SAVE, "SRF", FreqDir )
     config['Files']['dir_SRF_his'] = dir_SRF_his
     
 echo ( f'The analysis relies on files from the following model output directories : ' )
-echo ( f'{dir_ATM_his}' )
-echo ( f'{dir_SRF_his}' )
-
-#-- Files Names
-if Period == None :
+echo ( f'{dir_ATM_his = }' )
+echo ( f'{dir_SRF_his = }' )
+
+##-- Creates files names
+if wu.unDefined ( 'Period' ) :
     if Freq == 'MO' : Period = f'{YearBegin}0101_{YearEnd}1231_1M'
     if Freq == 'SE' : Period = f'SE_{YearBegin}0101_{YearEnd}1231_1M'
     config['Files']['Period'] = Period
-if FileCommon == None :
+if wu.unDefined ( 'FileCommon' ) :
     FileCommon = f'{JobName}_{Period}'
     config['Files']['FileCommon'] = FileCommon
 
-if Title == None :
+if wu.unDefined ( 'Title' ) :
     Title = f'{JobName} : {Freq} : {YearBegin}-01-01 - {YearEnd}-12-31'
     config['Files']['Title'] = Title
      
 echo ('\nOpen history files' )
-if file_ATM_his == None : 
+if wu.unDefined ( 'file_ATM_his' ) : 
     file_ATM_his = os.path.join (  dir_ATM_his, f'{FileCommon}_histmth.nc' )
     config['Files']['file_ATM_his'] = file_ATM_his
-if file_SRF_his == None :
+if wu.unDefined ( 'file_SRF_his' ) :
     file_SRF_his = os.path.join (  dir_SRF_his, f'{FileCommon}_sechiba_history.nc' )
     config['Files']['file_SRF_his'] = file_SRF_his
@@ -257,39 +228,38 @@
 d_ATM_his = xr.open_dataset ( file_ATM_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
 d_SRF_his = xr.open_dataset ( file_SRF_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
-if Routing == 'SECHIBA' :
-    d_RUN_his = d_SRF_his
-if Routing == 'SIMPLE' : 
-    d_RUN_his = xr.open_dataset ( file_RUN_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
-
-echo ( file_ATM_his )
-echo ( file_SRF_his )
-if Routing == 'SIMPLE' : 
-    echo ( file_RUN_his )
-
-## Compute run length
+if Routing == 'SECHIBA' : d_RUN_his = d_SRF_his
+if Routing == 'SIMPLE'  : d_RUN_his = xr.open_dataset ( file_RUN_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
+
+echo ( f'{file_ATM_his = }' )
+echo ( f'{file_SRF_his = }' )
+if Routing == 'SIMPLE' : echo ( f'{file_RUN_his = }' )
+
+##-- Compute run length
 dtime = ( d_ATM_his.time_counter_bounds.max() - d_ATM_his.time_counter_bounds.min() )
 echo ('\nRun length : {:8.2f} days'.format ( (dtime/np.timedelta64(1, "D")).values ) )
 dtime_sec = (dtime/np.timedelta64(1, "s")).values.item() # Convert in seconds
 
-## Compute length of each period
+##-- Compute length of each period
 dtime_per = (d_ATM_his.time_counter_bounds[:,-1] -  d_ATM_his.time_counter_bounds[:,0] )
 echo ('\nPeriods lengths (days) : {:} days'.format ( (dtime_per/np.timedelta64(1, "D")).values ) )
 dtime_per_sec = (dtime_per/np.timedelta64(1, "s")).values # In seconds
 dtime_per_sec = xr.DataArray (dtime_per_sec, dims=["time_counter", ], coords=[d_ATM_his.time_counter,] )
-
-## Number of years
+dtime_per_sec.attrs['unit'] = 's'
+
+##-- Number of years (approximative)
 NbYear = dtime_sec / YearLength
 
-#-- Open restart files
-
+##-- Extract restart files from tar
 YearRes = YearBegin - 1              # Year of the restart of beginning of simulation
 YearPre = YearBegin - PackFrequency  # Year to find the tarfile of the restart of beginning of simulation
 
-if TarRestartPeriod_beg == None : 
+config['Files']['YearPre'] = f'{YearBegin}'
+
+if wu.unDefined ( 'TarRestartPeriod_beg' ) : 
     echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
     TarRestartPeriod_beg = f'{YearPre}0101_{YearRes}1231'
     config['Files']['TarRestartPeriod_beg'] = TarRestartPeriod_beg
 
-if TarRestartPeriod_end == None : 
+if wu.unDefined ( 'TarRestartPeriod_end ' ) : 
     YearPre = YearBegin - PackFrequency  # Year to find the tarfile of the restart of beginning of simulation
     echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
@@ -297,46 +267,58 @@
     config['Files']['TarRestartPeriod_end'] = TarRestartPeriod_end
 
-if file_restart_beg == None :
-    file_restart_beg = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_beg}_restart.tar' )
-    config['Files']['file_restart_beg'] = file_restart_beg
-if file_restart_end == None :
-    file_restart_end = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_end}_restart.tar' )
-    config['Files']['file_restart_end'] = file_restart_end
-    
-echo ( f'{file_restart_beg}' )
-echo ( f'{file_restart_end}' )
-
-if file_ATM_beg == None : 
-    file_ATM_beg = f'{TmpDir}/ATM_{JobName}_{YearRes}1231_restartphy.nc'
+if wu.unDefined ( 'tar_restart_beg' ) :
+    tar_restart_beg = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_beg}_restart.tar' )
+    config['Files']['tar_restart_beg'] = tar_restart_beg
+if wu.unDefined ( 'tar_restart_end' ) :
+    tar_restart_end = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_end}_restart.tar' )
+    config['Files']['tar_restart_end'] = tar_restart_end
+    
+echo ( f'{tar_restart_beg = }' )
+echo ( f'{tar_restart_end = }' )
+
+##-- Names of tar files with restarts
+if wu.unDefined ( 'SRF_HIS' ) : SRF_HIS = ATM_HIS
+
+if wu.unDefined ( 'tar_restart_beg_ATM' ) : tar_restart_beg_ATM = tar_restart_beg
+if wu.unDefined ( 'tar_restart_beg_DYN' ) : tar_restart_beg_DYN = tar_restart_beg
+if wu.unDefined ( 'tar_restart_beg_SRF' ) : tar_restart_beg_SRF = tar_restart_beg
+if wu.unDefined ( 'tar_restart_beg_RUN' ) : tar_restart_beg_RUN = tar_restart_beg
+if wu.unDefined ( 'tar_restart_beg_OCE' ) : tar_restart_beg_OCE = tar_restart_beg
+if wu.unDefined ( 'tar_restart_beg_ICE' ) : tar_restart_beg_ICE = tar_restart_beg
+
+if wu.unDefined ( 'tar_restart_end_ATM' ) : tar_restart_end_ATM = tar_restart_end
+if wu.unDefined ( 'tar_restart_end_DYN' ) : tar_restart_end_DYN = tar_restart_end
+if wu.unDefined ( 'tar_restart_end_SRF' ) : tar_restart_end_SRF = tar_restart_end
+if wu.unDefined ( 'tar_restart_end_RUN' ) : tar_restart_end_RUN = tar_restart_end
+if wu.unDefined ( 'tar_restart_end_OCE' ) : tar_restart_end_OCE = tar_restart_end
+if wu.unDefined ( 'tar_restart_end_ICE' ) : tar_restart_end_ICE = tar_restart_end
+
+if wu.unDefined ( 'file_ATM_beg' ) : 
+    file_ATM_beg = f'{RunDir}/ATM_{JobName}_{YearRes}1231_restartphy.nc'
     config['Files']['file_ATM_beg'] = file_ATM_beg
-if file_ATM_end == None :
-    file_ATM_end = f'{TmpDir}/ATM_{JobName}_{YearEnd}1231_restartphy.nc'
+if wu.unDefined ( 'file_ATM_end' ) :
+    file_ATM_end = f'{RunDir}/ATM_{JobName}_{YearEnd}1231_restartphy.nc'
     config['Files']['file_ATM_end'] = file_ATM_end
 
 liste_beg = [file_ATM_beg, ]
 liste_end = [file_ATM_end, ]
-    
-
-if file_DYN_beg == None :
-    if LMDZ :
-        file_DYN_beg = f'{TmpDir}/ATM_{JobName}_{YearRes}1231_restart.nc'
-    if ICO  :
-        file_DYN_beg = f'{TmpDir}/ICO_{JobName}_{YearRes}1231_restart.nc'
+
+if wu.unDefined ( 'file_DYN_beg' ) :
+    if LMDZ : file_DYN_beg = f'{RunDir}/ATM_{JobName}_{YearRes}1231_restart.nc'
+    if ICO  : file_DYN_beg = f'{RunDir}/ICO_{JobName}_{YearRes}1231_restart.nc'
     liste_beg.append (file_DYN_beg)
     config['Files']['file_DYN_beg'] = file_DYN_beg
     
-if file_DYN_end == None : 
-    if LMDZ :
-        file_DYN_end = f'{TmpDir}/ATM_{JobName}_{YearEnd}1231_restart.nc'
-    if ICO  :
-        file_DYN_end = f'{TmpDir}/ICO_{JobName}_{YearEnd}1231_restart.nc'
+if wu.unDefined ( 'file_DYN_end' ) : 
+    if LMDZ : file_DYN_end = f'{RunDir}/ATM_{JobName}_{YearEnd}1231_restart.nc'
+    if ICO  : file_DYN_end = f'{RunDir}/ICO_{JobName}_{YearEnd}1231_restart.nc'
     liste_end.append ( file_DYN_end )
     config['Files']['file_DYN_end'] = file_DYN_end
 
-if file_SRF_beg == None : 
-    file_SRF_beg = f'{TmpDir}/SRF_{JobName}_{YearRes}1231_sechiba_rest.nc'
+if wu.unDefined ( 'file_SRF_beg' ) :
+    file_SRF_beg = f'{RunDir}/SRF_{JobName}_{YearRes}1231_sechiba_rest.nc'
     config['Files']['file_SRF_beg'] = file_SRF_beg
-if file_SRF_end == None : 
-    file_SRF_end = f'{TmpDir}/SRF_{JobName}_{YearEnd}1231_sechiba_rest.nc'
+if wu.unDefined ( 'file_SRF_end' ) :
+    file_SRF_end = f'{RunDir}/SRF_{JobName}_{YearEnd}1231_sechiba_rest.nc'
     config['Files']['file_SRF_end'] = file_SRF_end
     
@@ -344,50 +326,86 @@
 liste_end.append ( file_SRF_end )
 
-echo ( f'{file_ATM_beg}')
-echo ( f'{file_ATM_end}')
-echo ( f'{file_DYN_beg}')
-echo ( f'{file_DYN_end}')
-echo ( f'{file_SRF_beg}')
-echo ( f'{file_SRF_end}')
+echo ( f'{file_ATM_beg = }')
+echo ( f'{file_ATM_end = }')
+echo ( f'{file_DYN_beg = }')
+echo ( f'{file_DYN_end = }')
+echo ( f'{file_SRF_beg = }')
+echo ( f'{file_SRF_end = }')
+
+if ICO :
+    if wu.unDefined ('file_DYN_aire') : file_DYN_aire = os.path.join ( R_IN, 'ATM', 'GRID', ATM+'_grid.nc' )
+    config['Files'] ['file_DYN_aire'] = file_DYN_aire
 
 if Routing == 'SIMPLE' :
-    if file_RUN_beg == None : 
-        file_RUN_beg = f'{TmpDir}/SRF_{JobName}_{YearRes}1231_routing_restart.nc'
+    if wu.unDefined ( 'file_RUN_beg' ) : 
+        file_RUN_beg = f'{RunDir}/SRF_{JobName}_{YearRes}1231_routing_restart.nc'
         config['Files']['file_RUN_beg'] = file_RUN_beg
-    if file_RUN_end == None : 
-        file_RUN_end = f'{TmpDir}/SRF_{JobName}_{YearEnd}1231_routing_restart.nc'
+    if wu.unDefined ( 'file_RUN_end' ) : 
+        file_RUN_end = f'{RunDir}/SRF_{JobName}_{YearEnd}1231_routing_restart.nc'
         config['Files']['file_RUN_end'] = file_RUN_end
         
     liste_beg.append ( file_RUN_beg )
     liste_end.append ( file_RUN_end )
-    echo ( f'{file_RUN_beg}')
-    echo ( f'{file_RUN_end}')
+    echo ( f'{file_RUN_beg = }' )
+    echo ( f'{file_RUN_end = }' )
 
 echo ('\nExtract restart files from tar : ATM, ICO and SRF')
-for resFile in liste_beg :
-    if os.path.exists ( os.path.join (TmpDir, resFile) ) :
-        echo ( f'file found : {resFile}' )
+
+def extract_and_rebuild ( file_name=file_ATM_beg, tar_restart=tar_restart_end, RunDirComp=RunDir, ErrorCount=ErrorCount ) :
+    echo ( f'----------')
+    echo ( f'file to extract : {file_name = }' )
+    if os.path.exists ( os.path.join (RunDir, file_name) ) :
+        echo ( f'file found : {file_name = }' )
     else :
-        base_resFile = os.path.basename (resFile)
-        command =  f'cd {TmpDir} ; tar xf {file_restart_beg} {base_resFile}'
-        echo ( command )
-        os.system ( command )
-        
-for resFile in liste_end :
-    if os.path.exists ( os.path.join (TmpDir, resFile) ) :
-        echo ( f'file found : {resFile}' )
-    else :
-        base_resFile = os.path.basename (resFile)
-        command =  f'cd {TmpDir} ; tar xf {file_restart_end} {base_resFile}'
-        echo ( command )
-        os.system ( command )
-       
+        echo ( f'file not found : {file_name = }' )
+        base_resFile = os.path.basename (file_name)
+        if os.path.exists ( tar_restart ) :
+            command =  f'cd {RunDir} ; tar xf {tar_restart} {base_resFile}'
+            echo ( f'{command = }' )
+            try : 
+                os.system ( command )
+            except :
+                if ContinueOnError :
+                    ErrorCount += 1
+                    echo ( f'****** Command failed : {command}' )
+                    echo ( f'****** Trying to continue' )
+                    echo ( ' ')
+                else :
+                    raise Exception ( f'**** command failed : {command} - Stopping' )
+            else :
+                echo ( f'tar done : {base_resFile}' )
+        else :
+            echo ( f'****** Tar restart file {tar_restart = } not found ' )
+            if ContinueOnError :
+                ErrorCount += 1
+            else : 
+                raise Exception ( f'****** tar file not found {tar_restart = } - Stopping' )
+    return ErrorCount
+ 
+ErrorCount += extract_and_rebuild ( file_name=file_ATM_beg, tar_restart=tar_restart_beg_ATM, RunDirComp=RunDir )
+ErrorCount += extract_and_rebuild ( file_name=file_DYN_beg, tar_restart=tar_restart_beg_DYN, RunDirComp=RunDir )
+ErrorCount += extract_and_rebuild ( file_name=file_SRF_beg, tar_restart=tar_restart_beg_SRF, RunDirComp=RunDir )
+
+ErrorCount += extract_and_rebuild ( file_name=file_ATM_end, tar_restart=tar_restart_end_ATM, RunDirComp=RunDir )
+ErrorCount += extract_and_rebuild ( file_name=file_DYN_end, tar_restart=tar_restart_end_DYN, RunDirComp=RunDir )
+ErrorCount += extract_and_rebuild ( file_name=file_SRF_end, tar_restart=tar_restart_end_SRF, RunDirComp=RunDir )
+
+if Routing == 'SIMPLE' :
+    ErrorCount += extract_and_rebuild ( file_name=file_RUN_beg, tar_restart=tar_restart_beg_RUN, RunDirComp=RunDir )
+    ErrorCount += extract_and_rebuild ( file_name=file_RUN_end, tar_restart=tar_restart_end_RUN, RunDirComp=RunDir )
+
+##-- Exit in case of error in the opening file phase
+if ErrorCount > 0 :
+    echo ( '  ' )
+    raise Exception ( f'**** Some files missing - Stopping - {ErrorCount = }' )
+
+## 
 echo ('\nOpening ATM SRF and ICO restart files')
-d_ATM_beg = xr.open_dataset ( os.path.join (TmpDir, file_ATM_beg), decode_times=False, decode_cf=True).squeeze()
-d_ATM_end = xr.open_dataset ( os.path.join (TmpDir, file_ATM_end), decode_times=False, decode_cf=True).squeeze()
-d_SRF_beg = xr.open_dataset ( os.path.join (TmpDir, file_SRF_beg), decode_times=False, decode_cf=True).squeeze()
-d_SRF_end = xr.open_dataset ( os.path.join (TmpDir, file_SRF_end), decode_times=False, decode_cf=True).squeeze()
-d_DYN_beg = xr.open_dataset ( os.path.join (TmpDir, file_DYN_beg), decode_times=False, decode_cf=True).squeeze()
-d_DYN_end = xr.open_dataset ( os.path.join (TmpDir, file_DYN_end), decode_times=False, decode_cf=True).squeeze()
+d_ATM_beg = xr.open_dataset ( os.path.join (RunDir, file_ATM_beg), decode_times=False, decode_cf=True ).squeeze()
+d_ATM_end = xr.open_dataset ( os.path.join (RunDir, file_ATM_end), decode_times=False, decode_cf=True ).squeeze()
+d_SRF_beg = xr.open_dataset ( os.path.join (RunDir, file_SRF_beg), decode_times=False, decode_cf=True ).squeeze()
+d_SRF_end = xr.open_dataset ( os.path.join (RunDir, file_SRF_end), decode_times=False, decode_cf=True ).squeeze()
+d_DYN_beg = xr.open_dataset ( os.path.join (RunDir, file_DYN_beg), decode_times=False, decode_cf=True ).squeeze()
+d_DYN_end = xr.open_dataset ( os.path.join (RunDir, file_DYN_end), decode_times=False, decode_cf=True ).squeeze()
 
 for var in d_SRF_beg.variables :
